vector-0.13.2.0: Efficient Arrays

Copyright | (c) Roman Leshchinskiy 2008-2010 Alexey Kuleshevich 2020-2022 Aleksey Khudyakov 2020-2022 Andrew Lelechenko 2020-2022
License | BSD-style
Maintainer | Haskell Libraries Team <libraries@haskell.org>
Stability | experimental
Portability | non-portable
Safe Haskell | None
Language | Haskell2010

Data.Vector.Primitive.Mutable

Contents

- Mutable vectors of primitive types
- Accessors
  - Length information
  - Extracting subvectors
  - Overlapping
- Construction
  - Initialisation
  - Growing
  - Restricting memory usage
- Accessing individual elements
- Folds
- Modifying vectors
  - Filling and copying
- Unsafe conversions
- Re-exports

Description

Mutable primitive vectors.

Synopsis

- data MVector s a = MVector !Int !Int !(MutableByteArray s)
- type IOVector = MVector RealWorld
- type STVector s = MVector s
- length :: Prim a => MVector s a -> Int
- null :: Prim a => MVector s a -> Bool
- slice :: Prim a => Int -> Int -> MVector s a -> MVector s a
- init :: Prim a => MVector s a -> MVector s a
- tail :: Prim a => MVector s a -> MVector s a
- take :: Prim a => Int -> MVector s a -> MVector s a
- drop :: Prim a => Int -> MVector s a -> MVector s a
- splitAt :: Prim a => Int -> MVector s a -> (MVector s a, MVector s a)
- unsafeSlice :: Prim a => Int -> Int -> MVector s a -> MVector s a
- unsafeInit :: Prim a => MVector s a -> MVector s a
- unsafeTail :: Prim a => MVector s a -> MVector s a
- unsafeTake :: Prim a => Int -> MVector s a -> MVector s a
- unsafeDrop :: Prim a => Int -> MVector s a -> MVector s a
- overlaps :: Prim a => MVector s a -> MVector s a -> Bool
- new :: (PrimMonad m, Prim a) => Int -> m (MVector (PrimState m) a)
- unsafeNew :: (PrimMonad m, Prim a) => Int -> m (MVector (PrimState m) a)
- replicate :: (PrimMonad m, Prim a) => Int -> a -> m (MVector (PrimState m) a)
- replicateM :: (PrimMonad m, Prim a) => Int -> m a -> m (MVector (PrimState m) a)
- generate :: (PrimMonad m, Prim a) => Int -> (Int -> a) -> m (MVector (PrimState m) a)
- generateM :: (PrimMonad m, Prim a) => Int -> (Int -> m a) -> m (MVector (PrimState m) a)
- clone :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> m (MVector (PrimState m) a)
- grow :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> m (MVector (PrimState m) a)
- unsafeGrow :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> m (MVector (PrimState m) a)
- clear :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> m ()
- read :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> m a
- readMaybe :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> m (Maybe a)
- write :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> a -> m ()
- modify :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> (a -> a) -> Int -> m ()
- modifyM :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> (a -> m a) -> Int -> m ()
- swap :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> Int -> m ()
- exchange :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> a -> m a
- unsafeRead :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> m a
- unsafeWrite :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> a -> m ()
- unsafeModify :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> (a -> a) -> Int -> m ()
- unsafeModifyM :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> (a -> m a) -> Int -> m ()
- unsafeSwap :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> Int -> m ()
- unsafeExchange :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> a -> m a
- mapM_ :: (PrimMonad m, Prim a) => (a -> m b) -> MVector (PrimState m) a -> m ()
- imapM_ :: (PrimMonad m, Prim a) => (Int -> a -> m b) -> MVector (PrimState m) a -> m ()
- forM_ :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> (a -> m b) -> m ()
- iforM_ :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> (Int -> a -> m b) -> m ()
- foldl :: (PrimMonad m, Prim a) => (b -> a -> b) -> b -> MVector (PrimState m) a -> m b
- foldl' :: (PrimMonad m, Prim a) => (b -> a -> b) -> b -> MVector (PrimState m) a -> m b
- foldM :: (PrimMonad m, Prim a) => (b -> a -> m b) -> b -> MVector (PrimState m) a -> m b
- foldM' :: (PrimMonad m, Prim a) => (b -> a -> m b) -> b -> MVector (PrimState m) a -> m b
- foldr :: (PrimMonad m, Prim a) => (a -> b -> b) -> b -> MVector (PrimState m) a -> m b
- foldr' :: (PrimMonad m, Prim a) => (a -> b -> b) -> b -> MVector (PrimState m) a -> m b
- foldrM :: (PrimMonad m, Prim a) => (a -> b -> m b) -> b -> MVector (PrimState m) a -> m b
- foldrM' :: (PrimMonad m, Prim a) => (a -> b -> m b) -> b -> MVector (PrimState m) a -> m b
- ifoldl :: (PrimMonad m, Prim a) => (b -> Int -> a -> b) -> b -> MVector (PrimState m) a -> m b
- ifoldl' :: (PrimMonad m, Prim a) => (b -> Int -> a -> b) -> b -> MVector (PrimState m) a -> m b
- ifoldM :: (PrimMonad m, Prim a) => (b -> Int -> a -> m b) -> b -> MVector (PrimState m) a -> m b
- ifoldM' :: (PrimMonad m, Prim a) => (b -> Int -> a -> m b) -> b -> MVector (PrimState m) a -> m b
- ifoldr :: (PrimMonad m, Prim a) => (Int -> a -> b -> b) -> b -> MVector (PrimState m) a -> m b
- ifoldr' :: (PrimMonad m, Prim a) => (Int -> a -> b -> b) -> b -> MVector (PrimState m) a -> m b
- ifoldrM :: (PrimMonad m, Prim a) => (Int -> a -> b -> m b) -> b -> MVector (PrimState m) a -> m b
- ifoldrM' :: (PrimMonad m, Prim a) => (Int -> a -> b -> m b) -> b -> MVector (PrimState m) a -> m b
- nextPermutation :: (PrimMonad m, Ord e, Prim e) => MVector (PrimState m) e -> m Bool
- nextPermutationBy :: (PrimMonad m, Prim e) => (e -> e -> Ordering) -> MVector (PrimState m) e -> m Bool
- prevPermutation :: (PrimMonad m, Ord e, Prim e) => MVector (PrimState m) e -> m Bool
- prevPermutationBy :: (PrimMonad m, Prim e) => (e -> e -> Ordering) -> MVector (PrimState m) e -> m Bool
- set :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> a -> m ()
- copy :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> MVector (PrimState m) a -> m ()
- move :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> MVector (PrimState m) a -> m ()
- unsafeCopy :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> MVector (PrimState m) a -> m ()
- unsafeMove :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> MVector (PrimState m) a -> m ()
- unsafeCoerceMVector :: Coercible a b => MVector s a -> MVector s b
- unsafeCast :: (HasCallStack, Prim a, Prim b) => MVector s a -> MVector s b
- class Prim a
- class Monad m => PrimMonad (m :: Type -> Type)
- type family PrimState (m :: Type -> Type)
- data RealWorld

# Mutable vectors of primitive types

data MVector s a Source #

Mutable vectors of primitive types.

Constructors

MVector |

Fields

- !Int

  offset

- !Int

  length

- !(MutableByteArray s)

  underlying mutable byte array

#### Instances

Instances details

Prim a => MVector MVector a Source # |

Instance details

Defined in Data.Vector.Primitive.Mutable

Methods

basicLength :: MVector s a -> Int Source #

basicUnsafeSlice :: Int -> Int -> MVector s a -> MVector s a Source #

basicOverlaps :: MVector s a -> MVector s a -> Bool Source #

basicUnsafeNew :: Int -> ST s (MVector s a) Source #

basicInitialize :: MVector s a -> ST s () Source #

basicUnsafeReplicate :: Int -> a -> ST s (MVector s a) Source #

basicUnsafeRead :: MVector s a -> Int -> ST s a Source #

basicUnsafeWrite :: MVector s a -> Int -> a -> ST s () Source #

basicClear :: MVector s a -> ST s () Source #

basicSet :: MVector s a -> a -> ST s () Source #

basicUnsafeCopy :: MVector s a -> MVector s a -> ST s () Source #

basicUnsafeMove :: MVector s a -> MVector s a -> ST s () Source #

basicUnsafeGrow :: MVector s a -> Int -> ST s (MVector s a) Source #

NFData1 (MVector s) Source # |
Instance details Defined in Data.Vector.Primitive.Mutable Methods liftRnf :: (a -> ()) -> MVector s a -> () Source #
NFData (MVector s a) Source # |
Instance details Defined in Data.Vector.Primitive.Mutable Methods rnf :: MVector s a -> () Source #

type IOVector = MVector RealWorld Source #

type STVector s = MVector s Source #

# Accessors

## Length information

length :: Prim a => MVector s a -> Int Source #

Length of the mutable vector.

null :: Prim a => MVector s a -> Bool Source #

Check whether the vector is empty.

## Extracting subvectors

slice Source #

Arguments

:: Prim a |
=> Int | `i` starting index
-> Int | `n` length
-> MVector s a |
-> MVector s a |

Yield a part of the mutable vector without copying it. The vector must contain at least `i+n` elements.

init :: Prim a => MVector s a -> MVector s a Source #

Drop the last element of the mutable vector without making a copy. If the vector is empty, an exception is thrown.

tail :: Prim a => MVector s a -> MVector s a Source #

Drop the first element of the mutable vector without making a copy. If the vector is empty, an exception is thrown.

take :: Prim a => Int -> MVector s a -> MVector s a Source #

Take the `n` first elements of the mutable vector without making a copy. For negative `n`, the empty vector is returned. If `n` is larger than the vector's length, the vector is returned unchanged.

drop :: Prim a => Int -> MVector s a -> MVector s a Source #

Drop the `n` first element of the mutable vector without making a copy. For negative `n`, the vector is returned unchanged. If `n` is larger than the vector's length, the empty vector is returned.

splitAt :: Prim a => Int -> MVector s a -> (MVector s a, MVector s a) Source #

O(1) Split the mutable vector into the first `n` elements and the remainder, without copying.

Note that ``splitAt` n v` is equivalent to `(`take` n v, `drop` n v)`, but slightly more efficient.

unsafeSlice Source #

Arguments

:: Prim a |
=> Int | starting index
-> Int | length of the slice
-> MVector s a |
-> MVector s a |

Yield a part of the mutable vector without copying it. No bounds checks are performed.

unsafeInit :: Prim a => MVector s a -> MVector s a Source #

Same as `init`, but doesn't do range checks.

unsafeTail :: Prim a => MVector s a -> MVector s a Source #

Same as `tail`, but doesn't do range checks.

unsafeTake :: Prim a => Int -> MVector s a -> MVector s a Source #

Unsafe variant of `take`. If `n` is out of range, it will simply create an invalid slice that likely violate memory safety.

unsafeDrop :: Prim a => Int -> MVector s a -> MVector s a Source #

Unsafe variant of `drop`. If `n` is out of range, it will simply create an invalid slice that likely violate memory safety.

## Overlapping

overlaps :: Prim a => MVector s a -> MVector s a -> Bool Source #

Check whether two vectors overlap.

# Construction

## Initialisation

new :: (PrimMonad m, Prim a) => Int -> m (MVector (PrimState m) a) Source #

Create a mutable vector of the given length.

unsafeNew :: (PrimMonad m, Prim a) => Int -> m (MVector (PrimState m) a) Source #

Create a mutable vector of the given length. The vector content is uninitialized, which means it is filled with whatever the underlying memory buffer happens to contain.

Since: 0.5

replicate :: (PrimMonad m, Prim a) => Int -> a -> m (MVector (PrimState m) a) Source #

Create a mutable vector of the given length (0 if the length is negative) and fill it with an initial value.

replicateM :: (PrimMonad m, Prim a) => Int -> m a -> m (MVector (PrimState m) a) Source #

Create a mutable vector of the given length (0 if the length is negative) and fill it with values produced by repeatedly executing the monadic action.

generate :: (PrimMonad m, Prim a) => Int -> (Int -> a) -> m (MVector (PrimState m) a) Source #

O(n) Create a mutable vector of the given length (0 if the length is negative) and fill it with the results of applying the function to each index. Iteration starts at index 0.

Since: 0.12.3.0

generateM :: (PrimMonad m, Prim a) => Int -> (Int -> m a) -> m (MVector (PrimState m) a) Source #

O(n) Create a mutable vector of the given length (0 if the length is negative) and fill it with the results of applying the monadic function to each index. Iteration starts at index 0.

Since: 0.12.3.0

clone :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> m (MVector (PrimState m) a) Source #

Create a copy of a mutable vector.

## Growing

grow :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> m (MVector (PrimState m) a) Source #

Grow a primitive vector by the given number of elements. The number must be non-negative. This has the same semantics as `grow` for generic vectors.

#### Examples

Expand

    >>> import qualified Data.Vector.Primitive as VP
    >>> import qualified Data.Vector.Primitive.Mutable as MVP
    >>> mv <- VP.thaw $ VP.fromList ([10, 20, 30] :: [Int])
    >>> mv' <- MVP.grow mv 2

Extra memory at the end of the newly allocated vector is initialized to 0 bytes, which for `Prim` instances will usually correspond to some default value for a particular type, e.g. `0` for `Int`, `NUL` for `Char`, etc. However, if `unsafeGrow` was used instead, this would not have been guaranteed and some garbage would be there instead.

    >>> VP.freeze mv'
    [10,20,30,0,0]

Having the extra space we can write new values in there:

    >>> MVP.write mv' 3 999
    >>> VP.freeze mv'
    [10,20,30,999,0]

It is important to note that the source mutable vector is not affected when the newly allocated one is mutated.

    >>> MVP.write mv' 2 888
    >>> VP.freeze mv'
    [10,20,888,999,0]
    >>> VP.freeze mv
    [10,20,30]

Since: 0.5

unsafeGrow :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> m (MVector (PrimState m) a) Source #

Grow a vector by the given number of elements. The number must be non-negative, but this is not checked. This has the same semantics as `unsafeGrow` for generic vectors.

Since: 0.5

## Restricting memory usage

clear :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> m () Source #

Reset all elements of the vector to some undefined value, clearing all references to external objects. This is a noop.

# Accessing individual elements

read :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> m a Source #

Yield the element at the given position. Will throw an exception if the index is out of range.

#### Examples

Expand

    >>> import qualified Data.Vector.Primitive.Mutable as MVP
    >>> v <- MVP.generate 10 (\x -> x*x)
    >>> MVP.read v 3
    9

readMaybe :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> m (Maybe a) Source #

Yield the element at the given position. Returns `Nothing` if the index is out of range.

#### Examples

Expand

    >>> import qualified Data.Vector.Primitive.Mutable as MVP
    >>> v <- MVP.generate 10 (\x -> x*x)
    >>> MVP.readMaybe v 3
    Just 9
    >>> MVP.readMaybe v 13
    Nothing

Since: 0.13

write :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> a -> m () Source #

Replace the element at the given position.

modify :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> (a -> a) -> Int -> m () Source #

Modify the element at the given position.

modifyM :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> (a -> m a) -> Int -> m () Source #

Modify the element at the given position using a monadic function.

Since: 0.12.3.0

swap :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> Int -> m () Source #

Swap the elements at the given positions.

exchange :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> a -> m a Source #

Replace the element at the given position and return the old element.

unsafeRead :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> m a Source #

Yield the element at the given position. No bounds checks are performed.

unsafeWrite :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> a -> m () Source #

Replace the element at the given position. No bounds checks are performed.

unsafeModify :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> (a -> a) -> Int -> m () Source #

Modify the element at the given position. No bounds checks are performed.

unsafeModifyM :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> (a -> m a) -> Int -> m () Source #

Modify the element at the given position using a monadic function. No bounds checks are performed.

Since: 0.12.3.0

unsafeSwap :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> Int -> m () Source #

Swap the elements at the given positions. No bounds checks are performed.

unsafeExchange :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> Int -> a -> m a Source #

Replace the element at the given position and return the old element. No bounds checks are performed.

# Folds

mapM_ :: (PrimMonad m, Prim a) => (a -> m b) -> MVector (PrimState m) a -> m () Source #

O(n) Apply the monadic action to every element of the vector, discarding the results.

Since: 0.12.3.0

imapM_ :: (PrimMonad m, Prim a) => (Int -> a -> m b) -> MVector (PrimState m) a -> m () Source #

O(n) Apply the monadic action to every element of the vector and its index, discarding the results.

Since: 0.12.3.0

forM_ :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> (a -> m b) -> m () Source #

O(n) Apply the monadic action to every element of the vector, discarding the results. It's the same as `flip mapM_`.

Since: 0.12.3.0

iforM_ :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> (Int -> a -> m b) -> m () Source #

O(n) Apply the monadic action to every element of the vector and its index, discarding the results. It's the same as `flip imapM_`.

Since: 0.12.3.0

foldl :: (PrimMonad m, Prim a) => (b -> a -> b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Pure left fold.

Since: 0.12.3.0

foldl' :: (PrimMonad m, Prim a) => (b -> a -> b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Pure left fold with strict accumulator.

Since: 0.12.3.0

foldM :: (PrimMonad m, Prim a) => (b -> a -> m b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Monadic fold.

Since: 0.12.3.0

foldM' :: (PrimMonad m, Prim a) => (b -> a -> m b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Monadic fold with strict accumulator.

Since: 0.12.3.0

foldr :: (PrimMonad m, Prim a) => (a -> b -> b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Pure right fold.

Since: 0.12.3.0

foldr' :: (PrimMonad m, Prim a) => (a -> b -> b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Pure right fold with strict accumulator.

Since: 0.12.3.0

foldrM :: (PrimMonad m, Prim a) => (a -> b -> m b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Monadic right fold.

Since: 0.12.3.0

foldrM' :: (PrimMonad m, Prim a) => (a -> b -> m b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Monadic right fold with strict accumulator.

Since: 0.12.3.0

ifoldl :: (PrimMonad m, Prim a) => (b -> Int -> a -> b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Pure left fold using a function applied to each element and its index.

Since: 0.12.3.0

ifoldl' :: (PrimMonad m, Prim a) => (b -> Int -> a -> b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Pure left fold with strict accumulator using a function applied to each element and its index.

Since: 0.12.3.0

ifoldM :: (PrimMonad m, Prim a) => (b -> Int -> a -> m b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Monadic fold using a function applied to each element and its index.

Since: 0.12.3.0

ifoldM' :: (PrimMonad m, Prim a) => (b -> Int -> a -> m b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Monadic fold with strict accumulator using a function applied to each element and its index.

Since: 0.12.3.0

ifoldr :: (PrimMonad m, Prim a) => (Int -> a -> b -> b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Pure right fold using a function applied to each element and its index.

Since: 0.12.3.0

ifoldr' :: (PrimMonad m, Prim a) => (Int -> a -> b -> b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Pure right fold with strict accumulator using a function applied to each element and its index.

Since: 0.12.3.0

ifoldrM :: (PrimMonad m, Prim a) => (Int -> a -> b -> m b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Monadic right fold using a function applied to each element and its index.

Since: 0.12.3.0

ifoldrM' :: (PrimMonad m, Prim a) => (Int -> a -> b -> m b) -> b -> MVector (PrimState m) a -> m b Source #

O(n) Monadic right fold with strict accumulator using a function applied to each element and its index.

Since: 0.12.3.0

# Modifying vectors

nextPermutation :: (PrimMonad m, Ord e, Prim e) => MVector (PrimState m) e -> m Bool Source #

Compute the (lexicographically) next permutation of the given vector in-place. Returns False when the input is the last item in the enumeration, i.e., if it is in weakly descending order. In this case the vector will not get updated, as opposed to the behavior of the C++ function `std::next_permutation`.

nextPermutationBy :: (PrimMonad m, Prim e) => (e -> e -> Ordering) -> MVector (PrimState m) e -> m Bool Source #

Compute the (lexicographically) next permutation of the given vector in-place, using the provided comparison function. Returns False when the input is the last item in the enumeration, i.e., if it is in weakly descending order. In this case the vector will not get updated, as opposed to the behavior of the C++ function `std::next_permutation`.

Since: 0.13.2.0

prevPermutation :: (PrimMonad m, Ord e, Prim e) => MVector (PrimState m) e -> m Bool Source #

Compute the (lexicographically) previous permutation of the given vector in-place. Returns False when the input is the last item in the enumeration, i.e., if it is in weakly ascending order. In this case the vector will not get updated, as opposed to the behavior of the C++ function `std::prev_permutation`.

Since: 0.13.2.0

prevPermutationBy :: (PrimMonad m, Prim e) => (e -> e -> Ordering) -> MVector (PrimState m) e -> m Bool Source #

Compute the (lexicographically) previous permutation of the given vector in-place, using the provided comparison function. Returns False when the input is the last item in the enumeration, i.e., if it is in weakly ascending order. In this case the vector will not get updated, as opposed to the behavior of the C++ function `std::prev_permutation`.

Since: 0.13.2.0

## Filling and copying

set :: (PrimMonad m, Prim a) => MVector (PrimState m) a -> a -> m () Source #

Set all elements of the vector to the given value.

copy Source #

Arguments

:: (PrimMonad m, Prim a) |
=> MVector (PrimState m) a | target
-> MVector (PrimState m) a | source
-> m () |

Copy a vector. The two vectors must have the same length and may not overlap.

move Source #

Arguments

:: (PrimMonad m, Prim a) |
=> MVector (PrimState m) a | target
-> MVector (PrimState m) a | source
-> m () |

Move the contents of a vector. The two vectors must have the same length.

If the vectors do not overlap, then this is equivalent to `copy`. Otherwise, the copying is performed as if the source vector were copied to a temporary vector and then the temporary vector was copied to the target vector.

unsafeCopy Source #

Arguments

:: (PrimMonad m, Prim a) |
=> MVector (PrimState m) a | target
-> MVector (PrimState m) a | source
-> m () |

Copy a vector. The two vectors must have the same length and may not overlap, but this is not checked.

unsafeMove Source #

Arguments

:: (PrimMonad m, Prim a) |
=> MVector (PrimState m) a | target
-> MVector (PrimState m) a | source
-> m () |

Move the contents of a vector. The two vectors must have the same length, but this is not checked.

If the vectors do not overlap, then this is equivalent to `unsafeCopy`. Otherwise, the copying is performed as if the source vector were copied to a temporary vector and then the temporary vector was copied to the target vector.

# Unsafe conversions

unsafeCoerceMVector :: Coercible a b => MVector s a -> MVector s b Source #

O(1) Unsafely coerce a mutable vector from one element type to another, representationally equal type. The operation just changes the type of the underlying pointer and does not modify the elements.

Note that this function is unsafe. The `Coercible` constraint guarantees that the element types are representationally equal. It however cannot guarantee that their respective `Prim` instances are compatible.

unsafeCast :: (HasCallStack, Prim a, Prim b) => MVector s a -> MVector s b Source #

O(1) Unsafely cast a vector from one element type to another. This operation just changes the type of the vector and does not modify the elements.

This function will throw an error if elements are of mismatching sizes.

| @since 0.13.0.0

# Re-exports

class Prim a Source #

Class of types supporting primitive array operations. This includes interfacing with GC-managed memory (functions suffixed with `ByteArray#`) and interfacing with unmanaged memory (functions suffixed with `Addr#`). Endianness is platform-dependent.

Minimal complete definition

(sizeOfType# | sizeOf#), (alignmentOfType# | alignment#), indexByteArray#, readByteArray#, writeByteArray#, indexOffAddr#, readOffAddr#, writeOffAddr#

#### Instances

Instances details

Prim CBool |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CBool -> Int# Source #

sizeOf# :: CBool -> Int# Source #

alignmentOfType# :: Proxy CBool -> Int# Source #

alignment# :: CBool -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CBool Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CBool #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CBool -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CBool -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CBool Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CBool #) Source #

writeOffAddr# :: Addr# -> Int# -> CBool -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CBool -> State# s -> State# s Source #

Prim CChar |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CChar -> Int# Source #

sizeOf# :: CChar -> Int# Source #

alignmentOfType# :: Proxy CChar -> Int# Source #

alignment# :: CChar -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CChar Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CChar #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CChar -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CChar -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CChar Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CChar #) Source #

writeOffAddr# :: Addr# -> Int# -> CChar -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CChar -> State# s -> State# s Source #

Prim CClock |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CClock -> Int# Source #

sizeOf# :: CClock -> Int# Source #

alignmentOfType# :: Proxy CClock -> Int# Source #

alignment# :: CClock -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CClock Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CClock #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CClock -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CClock -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CClock Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CClock #) Source #

writeOffAddr# :: Addr# -> Int# -> CClock -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CClock -> State# s -> State# s Source #

Prim CDouble |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CDouble -> Int# Source #

sizeOf# :: CDouble -> Int# Source #

alignmentOfType# :: Proxy CDouble -> Int# Source #

alignment# :: CDouble -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CDouble Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CDouble #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CDouble -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CDouble -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CDouble Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CDouble #) Source #

writeOffAddr# :: Addr# -> Int# -> CDouble -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CDouble -> State# s -> State# s Source #

Prim CFloat |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CFloat -> Int# Source #

sizeOf# :: CFloat -> Int# Source #

alignmentOfType# :: Proxy CFloat -> Int# Source #

alignment# :: CFloat -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CFloat Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CFloat #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CFloat -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CFloat -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CFloat Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CFloat #) Source #

writeOffAddr# :: Addr# -> Int# -> CFloat -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CFloat -> State# s -> State# s Source #

Prim CInt |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CInt -> Int# Source #

sizeOf# :: CInt -> Int# Source #

alignmentOfType# :: Proxy CInt -> Int# Source #

alignment# :: CInt -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CInt Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CInt #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CInt -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CInt -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CInt Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CInt #) Source #

writeOffAddr# :: Addr# -> Int# -> CInt -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CInt -> State# s -> State# s Source #

Prim CIntMax |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CIntMax -> Int# Source #

sizeOf# :: CIntMax -> Int# Source #

alignmentOfType# :: Proxy CIntMax -> Int# Source #

alignment# :: CIntMax -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CIntMax Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CIntMax #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CIntMax -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CIntMax -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CIntMax Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CIntMax #) Source #

writeOffAddr# :: Addr# -> Int# -> CIntMax -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CIntMax -> State# s -> State# s Source #

Prim CIntPtr |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CIntPtr -> Int# Source #

sizeOf# :: CIntPtr -> Int# Source #

alignmentOfType# :: Proxy CIntPtr -> Int# Source #

alignment# :: CIntPtr -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CIntPtr Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CIntPtr #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CIntPtr -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CIntPtr -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CIntPtr Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CIntPtr #) Source #

writeOffAddr# :: Addr# -> Int# -> CIntPtr -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CIntPtr -> State# s -> State# s Source #

Prim CLLong |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CLLong -> Int# Source #

sizeOf# :: CLLong -> Int# Source #

alignmentOfType# :: Proxy CLLong -> Int# Source #

alignment# :: CLLong -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CLLong Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CLLong #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CLLong -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CLLong -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CLLong Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CLLong #) Source #

writeOffAddr# :: Addr# -> Int# -> CLLong -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CLLong -> State# s -> State# s Source #

Prim CLong |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CLong -> Int# Source #

sizeOf# :: CLong -> Int# Source #

alignmentOfType# :: Proxy CLong -> Int# Source #

alignment# :: CLong -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CLong Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CLong #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CLong -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CLong -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CLong Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CLong #) Source #

writeOffAddr# :: Addr# -> Int# -> CLong -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CLong -> State# s -> State# s Source #

Prim CPtrdiff |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CPtrdiff -> Int# Source #

sizeOf# :: CPtrdiff -> Int# Source #

alignmentOfType# :: Proxy CPtrdiff -> Int# Source #

alignment# :: CPtrdiff -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CPtrdiff Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CPtrdiff #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CPtrdiff -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CPtrdiff -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CPtrdiff Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CPtrdiff #) Source #

writeOffAddr# :: Addr# -> Int# -> CPtrdiff -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CPtrdiff -> State# s -> State# s Source #

Prim CSChar |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CSChar -> Int# Source #

sizeOf# :: CSChar -> Int# Source #

alignmentOfType# :: Proxy CSChar -> Int# Source #

alignment# :: CSChar -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CSChar Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CSChar #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CSChar -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CSChar -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CSChar Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CSChar #) Source #

writeOffAddr# :: Addr# -> Int# -> CSChar -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CSChar -> State# s -> State# s Source #

Prim CSUSeconds |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CSUSeconds -> Int# Source #

sizeOf# :: CSUSeconds -> Int# Source #

alignmentOfType# :: Proxy CSUSeconds -> Int# Source #

alignment# :: CSUSeconds -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CSUSeconds Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CSUSeconds #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CSUSeconds -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CSUSeconds -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CSUSeconds Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CSUSeconds #) Source #

writeOffAddr# :: Addr# -> Int# -> CSUSeconds -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CSUSeconds -> State# s -> State# s Source #

Prim CShort |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CShort -> Int# Source #

sizeOf# :: CShort -> Int# Source #

alignmentOfType# :: Proxy CShort -> Int# Source #

alignment# :: CShort -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CShort Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CShort #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CShort -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CShort -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CShort Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CShort #) Source #

writeOffAddr# :: Addr# -> Int# -> CShort -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CShort -> State# s -> State# s Source #

Prim CSigAtomic |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CSigAtomic -> Int# Source #

sizeOf# :: CSigAtomic -> Int# Source #

alignmentOfType# :: Proxy CSigAtomic -> Int# Source #

alignment# :: CSigAtomic -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CSigAtomic Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CSigAtomic #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CSigAtomic -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CSigAtomic -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CSigAtomic Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CSigAtomic #) Source #

writeOffAddr# :: Addr# -> Int# -> CSigAtomic -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CSigAtomic -> State# s -> State# s Source #

Prim CSize |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CSize -> Int# Source #

sizeOf# :: CSize -> Int# Source #

alignmentOfType# :: Proxy CSize -> Int# Source #

alignment# :: CSize -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CSize Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CSize #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CSize -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CSize -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CSize Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CSize #) Source #

writeOffAddr# :: Addr# -> Int# -> CSize -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CSize -> State# s -> State# s Source #

Prim CTime |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CTime -> Int# Source #

sizeOf# :: CTime -> Int# Source #

alignmentOfType# :: Proxy CTime -> Int# Source #

alignment# :: CTime -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CTime Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CTime #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CTime -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CTime -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CTime Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CTime #) Source #

writeOffAddr# :: Addr# -> Int# -> CTime -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CTime -> State# s -> State# s Source #

Prim CUChar |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CUChar -> Int# Source #

sizeOf# :: CUChar -> Int# Source #

alignmentOfType# :: Proxy CUChar -> Int# Source #

alignment# :: CUChar -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CUChar Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CUChar #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CUChar -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CUChar -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CUChar Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CUChar #) Source #

writeOffAddr# :: Addr# -> Int# -> CUChar -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CUChar -> State# s -> State# s Source #

Prim CUInt |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CUInt -> Int# Source #

sizeOf# :: CUInt -> Int# Source #

alignmentOfType# :: Proxy CUInt -> Int# Source #

alignment# :: CUInt -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CUInt Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CUInt #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CUInt -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CUInt -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CUInt Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CUInt #) Source #

writeOffAddr# :: Addr# -> Int# -> CUInt -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CUInt -> State# s -> State# s Source #

Prim CUIntMax |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CUIntMax -> Int# Source #

sizeOf# :: CUIntMax -> Int# Source #

alignmentOfType# :: Proxy CUIntMax -> Int# Source #

alignment# :: CUIntMax -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CUIntMax Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CUIntMax #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CUIntMax -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CUIntMax -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CUIntMax Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CUIntMax #) Source #

writeOffAddr# :: Addr# -> Int# -> CUIntMax -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CUIntMax -> State# s -> State# s Source #

Prim CUIntPtr |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CUIntPtr -> Int# Source #

sizeOf# :: CUIntPtr -> Int# Source #

alignmentOfType# :: Proxy CUIntPtr -> Int# Source #

alignment# :: CUIntPtr -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CUIntPtr Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CUIntPtr #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CUIntPtr -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CUIntPtr -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CUIntPtr Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CUIntPtr #) Source #

writeOffAddr# :: Addr# -> Int# -> CUIntPtr -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CUIntPtr -> State# s -> State# s Source #

Prim CULLong |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CULLong -> Int# Source #

sizeOf# :: CULLong -> Int# Source #

alignmentOfType# :: Proxy CULLong -> Int# Source #

alignment# :: CULLong -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CULLong Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CULLong #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CULLong -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CULLong -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CULLong Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CULLong #) Source #

writeOffAddr# :: Addr# -> Int# -> CULLong -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CULLong -> State# s -> State# s Source #

Prim CULong |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CULong -> Int# Source #

sizeOf# :: CULong -> Int# Source #

alignmentOfType# :: Proxy CULong -> Int# Source #

alignment# :: CULong -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CULong Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CULong #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CULong -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CULong -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CULong Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CULong #) Source #

writeOffAddr# :: Addr# -> Int# -> CULong -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CULong -> State# s -> State# s Source #

Prim CUSeconds |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CUSeconds -> Int# Source #

sizeOf# :: CUSeconds -> Int# Source #

alignmentOfType# :: Proxy CUSeconds -> Int# Source #

alignment# :: CUSeconds -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CUSeconds Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CUSeconds #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CUSeconds -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CUSeconds -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CUSeconds Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CUSeconds #) Source #

writeOffAddr# :: Addr# -> Int# -> CUSeconds -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CUSeconds -> State# s -> State# s Source #

Prim CUShort |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CUShort -> Int# Source #

sizeOf# :: CUShort -> Int# Source #

alignmentOfType# :: Proxy CUShort -> Int# Source #

alignment# :: CUShort -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CUShort Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CUShort #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CUShort -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CUShort -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CUShort Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CUShort #) Source #

writeOffAddr# :: Addr# -> Int# -> CUShort -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CUShort -> State# s -> State# s Source #

Prim CWchar |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CWchar -> Int# Source #

sizeOf# :: CWchar -> Int# Source #

alignmentOfType# :: Proxy CWchar -> Int# Source #

alignment# :: CWchar -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CWchar Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CWchar #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CWchar -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CWchar -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CWchar Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CWchar #) Source #

writeOffAddr# :: Addr# -> Int# -> CWchar -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CWchar -> State# s -> State# s Source #

Prim IntPtr | Since: primitive-0.7.1.0

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy IntPtr -> Int# Source #

sizeOf# :: IntPtr -> Int# Source #

alignmentOfType# :: Proxy IntPtr -> Int# Source #

alignment# :: IntPtr -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> IntPtr Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, IntPtr #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> IntPtr -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> IntPtr -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> IntPtr Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, IntPtr #) Source #

writeOffAddr# :: Addr# -> Int# -> IntPtr -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> IntPtr -> State# s -> State# s Source #

Prim WordPtr | Since: primitive-0.7.1.0

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy WordPtr -> Int# Source #

sizeOf# :: WordPtr -> Int# Source #

alignmentOfType# :: Proxy WordPtr -> Int# Source #

alignment# :: WordPtr -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> WordPtr Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, WordPtr #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> WordPtr -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> WordPtr -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> WordPtr Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, WordPtr #) Source #

writeOffAddr# :: Addr# -> Int# -> WordPtr -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> WordPtr -> State# s -> State# s Source #

Prim Int16 |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy Int16 -> Int# Source #

sizeOf# :: Int16 -> Int# Source #

alignmentOfType# :: Proxy Int16 -> Int# Source #

alignment# :: Int16 -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Int16 Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Int16 #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Int16 -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Int16 -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Int16 Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Int16 #) Source #

writeOffAddr# :: Addr# -> Int# -> Int16 -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Int16 -> State# s -> State# s Source #

Prim Int32 |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy Int32 -> Int# Source #

sizeOf# :: Int32 -> Int# Source #

alignmentOfType# :: Proxy Int32 -> Int# Source #

alignment# :: Int32 -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Int32 Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Int32 #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Int32 -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Int32 -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Int32 Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Int32 #) Source #

writeOffAddr# :: Addr# -> Int# -> Int32 -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Int32 -> State# s -> State# s Source #

Prim Int64 |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy Int64 -> Int# Source #

sizeOf# :: Int64 -> Int# Source #

alignmentOfType# :: Proxy Int64 -> Int# Source #

alignment# :: Int64 -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Int64 Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Int64 #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Int64 -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Int64 -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Int64 Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Int64 #) Source #

writeOffAddr# :: Addr# -> Int# -> Int64 -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Int64 -> State# s -> State# s Source #

Prim Int8 |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy Int8 -> Int# Source #

sizeOf# :: Int8 -> Int# Source #

alignmentOfType# :: Proxy Int8 -> Int# Source #

alignment# :: Int8 -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Int8 Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Int8 #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Int8 -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Int8 -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Int8 Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Int8 #) Source #

writeOffAddr# :: Addr# -> Int# -> Int8 -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Int8 -> State# s -> State# s Source #

Prim CBlkCnt |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CBlkCnt -> Int# Source #

sizeOf# :: CBlkCnt -> Int# Source #

alignmentOfType# :: Proxy CBlkCnt -> Int# Source #

alignment# :: CBlkCnt -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CBlkCnt Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CBlkCnt #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CBlkCnt -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CBlkCnt -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CBlkCnt Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CBlkCnt #) Source #

writeOffAddr# :: Addr# -> Int# -> CBlkCnt -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CBlkCnt -> State# s -> State# s Source #

Prim CBlkSize |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CBlkSize -> Int# Source #

sizeOf# :: CBlkSize -> Int# Source #

alignmentOfType# :: Proxy CBlkSize -> Int# Source #

alignment# :: CBlkSize -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CBlkSize Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CBlkSize #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CBlkSize -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CBlkSize -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CBlkSize Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CBlkSize #) Source #

writeOffAddr# :: Addr# -> Int# -> CBlkSize -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CBlkSize -> State# s -> State# s Source #

Prim CCc |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CCc -> Int# Source #

sizeOf# :: CCc -> Int# Source #

alignmentOfType# :: Proxy CCc -> Int# Source #

alignment# :: CCc -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CCc Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CCc #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CCc -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CCc -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CCc Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CCc #) Source #

writeOffAddr# :: Addr# -> Int# -> CCc -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CCc -> State# s -> State# s Source #

Prim CClockId |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CClockId -> Int# Source #

sizeOf# :: CClockId -> Int# Source #

alignmentOfType# :: Proxy CClockId -> Int# Source #

alignment# :: CClockId -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CClockId Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CClockId #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CClockId -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CClockId -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CClockId Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CClockId #) Source #

writeOffAddr# :: Addr# -> Int# -> CClockId -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CClockId -> State# s -> State# s Source #

Prim CDev |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CDev -> Int# Source #

sizeOf# :: CDev -> Int# Source #

alignmentOfType# :: Proxy CDev -> Int# Source #

alignment# :: CDev -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CDev Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CDev #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CDev -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CDev -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CDev Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CDev #) Source #

writeOffAddr# :: Addr# -> Int# -> CDev -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CDev -> State# s -> State# s Source #

Prim CFsBlkCnt |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CFsBlkCnt -> Int# Source #

sizeOf# :: CFsBlkCnt -> Int# Source #

alignmentOfType# :: Proxy CFsBlkCnt -> Int# Source #

alignment# :: CFsBlkCnt -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CFsBlkCnt Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CFsBlkCnt #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CFsBlkCnt -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CFsBlkCnt -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CFsBlkCnt Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CFsBlkCnt #) Source #

writeOffAddr# :: Addr# -> Int# -> CFsBlkCnt -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CFsBlkCnt -> State# s -> State# s Source #

Prim CFsFilCnt |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CFsFilCnt -> Int# Source #

sizeOf# :: CFsFilCnt -> Int# Source #

alignmentOfType# :: Proxy CFsFilCnt -> Int# Source #

alignment# :: CFsFilCnt -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CFsFilCnt Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CFsFilCnt #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CFsFilCnt -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CFsFilCnt -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CFsFilCnt Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CFsFilCnt #) Source #

writeOffAddr# :: Addr# -> Int# -> CFsFilCnt -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CFsFilCnt -> State# s -> State# s Source #

Prim CGid |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CGid -> Int# Source #

sizeOf# :: CGid -> Int# Source #

alignmentOfType# :: Proxy CGid -> Int# Source #

alignment# :: CGid -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CGid Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CGid #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CGid -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CGid -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CGid Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CGid #) Source #

writeOffAddr# :: Addr# -> Int# -> CGid -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CGid -> State# s -> State# s Source #

Prim CId |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CId -> Int# Source #

sizeOf# :: CId -> Int# Source #

alignmentOfType# :: Proxy CId -> Int# Source #

alignment# :: CId -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CId Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CId #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CId -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CId -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CId Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CId #) Source #

writeOffAddr# :: Addr# -> Int# -> CId -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CId -> State# s -> State# s Source #

Prim CIno |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CIno -> Int# Source #

sizeOf# :: CIno -> Int# Source #

alignmentOfType# :: Proxy CIno -> Int# Source #

alignment# :: CIno -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CIno Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CIno #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CIno -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CIno -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CIno Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CIno #) Source #

writeOffAddr# :: Addr# -> Int# -> CIno -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CIno -> State# s -> State# s Source #

Prim CKey |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CKey -> Int# Source #

sizeOf# :: CKey -> Int# Source #

alignmentOfType# :: Proxy CKey -> Int# Source #

alignment# :: CKey -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CKey Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CKey #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CKey -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CKey -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CKey Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CKey #) Source #

writeOffAddr# :: Addr# -> Int# -> CKey -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CKey -> State# s -> State# s Source #

Prim CMode |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CMode -> Int# Source #

sizeOf# :: CMode -> Int# Source #

alignmentOfType# :: Proxy CMode -> Int# Source #

alignment# :: CMode -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CMode Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CMode #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CMode -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CMode -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CMode Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CMode #) Source #

writeOffAddr# :: Addr# -> Int# -> CMode -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CMode -> State# s -> State# s Source #

Prim CNlink |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CNlink -> Int# Source #

sizeOf# :: CNlink -> Int# Source #

alignmentOfType# :: Proxy CNlink -> Int# Source #

alignment# :: CNlink -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CNlink Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CNlink #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CNlink -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CNlink -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CNlink Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CNlink #) Source #

writeOffAddr# :: Addr# -> Int# -> CNlink -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CNlink -> State# s -> State# s Source #

Prim COff |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy COff -> Int# Source #

sizeOf# :: COff -> Int# Source #

alignmentOfType# :: Proxy COff -> Int# Source #

alignment# :: COff -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> COff Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, COff #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> COff -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> COff -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> COff Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, COff #) Source #

writeOffAddr# :: Addr# -> Int# -> COff -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> COff -> State# s -> State# s Source #

Prim CPid |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CPid -> Int# Source #

sizeOf# :: CPid -> Int# Source #

alignmentOfType# :: Proxy CPid -> Int# Source #

alignment# :: CPid -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CPid Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CPid #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CPid -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CPid -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CPid Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CPid #) Source #

writeOffAddr# :: Addr# -> Int# -> CPid -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CPid -> State# s -> State# s Source #

Prim CRLim |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CRLim -> Int# Source #

sizeOf# :: CRLim -> Int# Source #

alignmentOfType# :: Proxy CRLim -> Int# Source #

alignment# :: CRLim -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CRLim Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CRLim #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CRLim -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CRLim -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CRLim Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CRLim #) Source #

writeOffAddr# :: Addr# -> Int# -> CRLim -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CRLim -> State# s -> State# s Source #

Prim CSpeed |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CSpeed -> Int# Source #

sizeOf# :: CSpeed -> Int# Source #

alignmentOfType# :: Proxy CSpeed -> Int# Source #

alignment# :: CSpeed -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CSpeed Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CSpeed #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CSpeed -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CSpeed -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CSpeed Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CSpeed #) Source #

writeOffAddr# :: Addr# -> Int# -> CSpeed -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CSpeed -> State# s -> State# s Source #

Prim CSsize |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CSsize -> Int# Source #

sizeOf# :: CSsize -> Int# Source #

alignmentOfType# :: Proxy CSsize -> Int# Source #

alignment# :: CSsize -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CSsize Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CSsize #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CSsize -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CSsize -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CSsize Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CSsize #) Source #

writeOffAddr# :: Addr# -> Int# -> CSsize -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CSsize -> State# s -> State# s Source #

Prim CTcflag |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CTcflag -> Int# Source #

sizeOf# :: CTcflag -> Int# Source #

alignmentOfType# :: Proxy CTcflag -> Int# Source #

alignment# :: CTcflag -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CTcflag Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CTcflag #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CTcflag -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CTcflag -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CTcflag Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CTcflag #) Source #

writeOffAddr# :: Addr# -> Int# -> CTcflag -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CTcflag -> State# s -> State# s Source #

Prim CTimer |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CTimer -> Int# Source #

sizeOf# :: CTimer -> Int# Source #

alignmentOfType# :: Proxy CTimer -> Int# Source #

alignment# :: CTimer -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CTimer Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CTimer #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CTimer -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CTimer -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CTimer Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CTimer #) Source #

writeOffAddr# :: Addr# -> Int# -> CTimer -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CTimer -> State# s -> State# s Source #

Prim CUid |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy CUid -> Int# Source #

sizeOf# :: CUid -> Int# Source #

alignmentOfType# :: Proxy CUid -> Int# Source #

alignment# :: CUid -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> CUid Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, CUid #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> CUid -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> CUid -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> CUid Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, CUid #) Source #

writeOffAddr# :: Addr# -> Int# -> CUid -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> CUid -> State# s -> State# s Source #

Prim Fd |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy Fd -> Int# Source #

sizeOf# :: Fd -> Int# Source #

alignmentOfType# :: Proxy Fd -> Int# Source #

alignment# :: Fd -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Fd Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Fd #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Fd -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Fd -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Fd Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Fd #) Source #

writeOffAddr# :: Addr# -> Int# -> Fd -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Fd -> State# s -> State# s Source #

Prim Word16 |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy Word16 -> Int# Source #

sizeOf# :: Word16 -> Int# Source #

alignmentOfType# :: Proxy Word16 -> Int# Source #

alignment# :: Word16 -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Word16 Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Word16 #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Word16 -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Word16 -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Word16 Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Word16 #) Source #

writeOffAddr# :: Addr# -> Int# -> Word16 -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Word16 -> State# s -> State# s Source #

Prim Word32 |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy Word32 -> Int# Source #

sizeOf# :: Word32 -> Int# Source #

alignmentOfType# :: Proxy Word32 -> Int# Source #

alignment# :: Word32 -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Word32 Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Word32 #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Word32 -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Word32 -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Word32 Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Word32 #) Source #

writeOffAddr# :: Addr# -> Int# -> Word32 -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Word32 -> State# s -> State# s Source #

Prim Word64 |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy Word64 -> Int# Source #

sizeOf# :: Word64 -> Int# Source #

alignmentOfType# :: Proxy Word64 -> Int# Source #

alignment# :: Word64 -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Word64 Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Word64 #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Word64 -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Word64 -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Word64 Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Word64 #) Source #

writeOffAddr# :: Addr# -> Int# -> Word64 -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Word64 -> State# s -> State# s Source #

Prim Word8 |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy Word8 -> Int# Source #

sizeOf# :: Word8 -> Int# Source #

alignmentOfType# :: Proxy Word8 -> Int# Source #

alignment# :: Word8 -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Word8 Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Word8 #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Word8 -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Word8 -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Word8 Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Word8 #) Source #

writeOffAddr# :: Addr# -> Int# -> Word8 -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Word8 -> State# s -> State# s Source #

Prim Char |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy Char -> Int# Source #

sizeOf# :: Char -> Int# Source #

alignmentOfType# :: Proxy Char -> Int# Source #

alignment# :: Char -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Char Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Char #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Char -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Char -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Char Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Char #) Source #

writeOffAddr# :: Addr# -> Int# -> Char -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Char -> State# s -> State# s Source #

Prim Double |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy Double -> Int# Source #

sizeOf# :: Double -> Int# Source #

alignmentOfType# :: Proxy Double -> Int# Source #

alignment# :: Double -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Double Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Double #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Double -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Double -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Double Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Double #) Source #

writeOffAddr# :: Addr# -> Int# -> Double -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Double -> State# s -> State# s Source #

Prim Float |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy Float -> Int# Source #

sizeOf# :: Float -> Int# Source #

alignmentOfType# :: Proxy Float -> Int# Source #

alignment# :: Float -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Float Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Float #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Float -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Float -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Float Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Float #) Source #

writeOffAddr# :: Addr# -> Int# -> Float -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Float -> State# s -> State# s Source #

Prim Int |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy Int -> Int# Source #

sizeOf# :: Int -> Int# Source #

alignmentOfType# :: Proxy Int -> Int# Source #

alignment# :: Int -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Int Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Int #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Int -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Int -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Int Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Int #) Source #

writeOffAddr# :: Addr# -> Int# -> Int -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Int -> State# s -> State# s Source #

Prim Word |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy Word -> Int# Source #

sizeOf# :: Word -> Int# Source #

alignmentOfType# :: Proxy Word -> Int# Source #

alignment# :: Word -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Word Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Word #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Word -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Word -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Word Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Word #) Source #

writeOffAddr# :: Addr# -> Int# -> Word -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Word -> State# s -> State# s Source #

Prim a => Prim (Complex a) | Since: primitive-0.9.0.0

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy (Complex a) -> Int# Source #

sizeOf# :: Complex a -> Int# Source #

alignmentOfType# :: Proxy (Complex a) -> Int# Source #

alignment# :: Complex a -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Complex a Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Complex a #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Complex a -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Complex a -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Complex a Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Complex a #) Source #

writeOffAddr# :: Addr# -> Int# -> Complex a -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Complex a -> State# s -> State# s Source #

Prim a => Prim (First a) | Since: primitive-0.6.5.0

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy (First a) -> Int# Source #

sizeOf# :: First a -> Int# Source #

alignmentOfType# :: Proxy (First a) -> Int# Source #

alignment# :: First a -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> First a Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, First a #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> First a -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> First a -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> First a Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, First a #) Source #

writeOffAddr# :: Addr# -> Int# -> First a -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> First a -> State# s -> State# s Source #

Prim a => Prim (Last a) | Since: primitive-0.6.5.0

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy (Last a) -> Int# Source #

sizeOf# :: Last a -> Int# Source #

alignmentOfType# :: Proxy (Last a) -> Int# Source #

alignment# :: Last a -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Last a Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Last a #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Last a -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Last a -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Last a Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Last a #) Source #

writeOffAddr# :: Addr# -> Int# -> Last a -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Last a -> State# s -> State# s Source #

Prim a => Prim (Max a) | Since: primitive-0.6.5.0

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy (Max a) -> Int# Source #

sizeOf# :: Max a -> Int# Source #

alignmentOfType# :: Proxy (Max a) -> Int# Source #

alignment# :: Max a -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Max a Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Max a #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Max a -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Max a -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Max a Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Max a #) Source #

writeOffAddr# :: Addr# -> Int# -> Max a -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Max a -> State# s -> State# s Source #

Prim a => Prim (Min a) | Since: primitive-0.6.5.0

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy (Min a) -> Int# Source #

sizeOf# :: Min a -> Int# Source #

alignmentOfType# :: Proxy (Min a) -> Int# Source #

alignment# :: Min a -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Min a Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Min a #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Min a -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Min a -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Min a Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Min a #) Source #

writeOffAddr# :: Addr# -> Int# -> Min a -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Min a -> State# s -> State# s Source #

Prim a => Prim (Identity a) | Since: primitive-0.6.5.0

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy (Identity a) -> Int# Source #

sizeOf# :: Identity a -> Int# Source #

alignmentOfType# :: Proxy (Identity a) -> Int# Source #

alignment# :: Identity a -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Identity a Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Identity a #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Identity a -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Identity a -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Identity a Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Identity a #) Source #

writeOffAddr# :: Addr# -> Int# -> Identity a -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Identity a -> State# s -> State# s Source #

Prim a => Prim (Down a) | Since: primitive-0.6.5.0

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy (Down a) -> Int# Source #

sizeOf# :: Down a -> Int# Source #

alignmentOfType# :: Proxy (Down a) -> Int# Source #

alignment# :: Down a -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Down a Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Down a #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Down a -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Down a -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Down a Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Down a #) Source #

writeOffAddr# :: Addr# -> Int# -> Down a -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Down a -> State# s -> State# s Source #

Prim a => Prim (Dual a) | Since: primitive-0.6.5.0

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy (Dual a) -> Int# Source #

sizeOf# :: Dual a -> Int# Source #

alignmentOfType# :: Proxy (Dual a) -> Int# Source #

alignment# :: Dual a -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Dual a Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Dual a #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Dual a -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Dual a -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Dual a Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Dual a #) Source #

writeOffAddr# :: Addr# -> Int# -> Dual a -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Dual a -> State# s -> State# s Source #

Prim a => Prim (Product a) | Since: primitive-0.6.5.0

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy (Product a) -> Int# Source #

sizeOf# :: Product a -> Int# Source #

alignmentOfType# :: Proxy (Product a) -> Int# Source #

alignment# :: Product a -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Product a Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Product a #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Product a -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Product a -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Product a Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Product a #) Source #

writeOffAddr# :: Addr# -> Int# -> Product a -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Product a -> State# s -> State# s Source #

Prim a => Prim (Sum a) | Since: primitive-0.6.5.0

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy (Sum a) -> Int# Source #

sizeOf# :: Sum a -> Int# Source #

alignmentOfType# :: Proxy (Sum a) -> Int# Source #

alignment# :: Sum a -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Sum a Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Sum a #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Sum a -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Sum a -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Sum a Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Sum a #) Source #

writeOffAddr# :: Addr# -> Int# -> Sum a -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Sum a -> State# s -> State# s Source #

Prim (FunPtr a) |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy (FunPtr a) -> Int# Source #

sizeOf# :: FunPtr a -> Int# Source #

alignmentOfType# :: Proxy (FunPtr a) -> Int# Source #

alignment# :: FunPtr a -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> FunPtr a Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, FunPtr a #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> FunPtr a -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> FunPtr a -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> FunPtr a Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, FunPtr a #) Source #

writeOffAddr# :: Addr# -> Int# -> FunPtr a -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> FunPtr a -> State# s -> State# s Source #

Prim (Ptr a) |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy (Ptr a) -> Int# Source #

sizeOf# :: Ptr a -> Int# Source #

alignmentOfType# :: Proxy (Ptr a) -> Int# Source #

alignment# :: Ptr a -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Ptr a Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Ptr a #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Ptr a -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Ptr a -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Ptr a Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Ptr a #) Source #

writeOffAddr# :: Addr# -> Int# -> Ptr a -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Ptr a -> State# s -> State# s Source #

Prim (StablePtr a) |

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy (StablePtr a) -> Int# Source #

sizeOf# :: StablePtr a -> Int# Source #

alignmentOfType# :: Proxy (StablePtr a) -> Int# Source #

alignment# :: StablePtr a -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> StablePtr a Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, StablePtr a #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> StablePtr a -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> StablePtr a -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> StablePtr a Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, StablePtr a #) Source #

writeOffAddr# :: Addr# -> Int# -> StablePtr a -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> StablePtr a -> State# s -> State# s Source #

Prim a => Prim (Const a b) | Since: primitive-0.6.5.0

Instance details

Defined in Data.Primitive.Types

Methods

sizeOfType# :: Proxy (Const a b) -> Int# Source #

sizeOf# :: Const a b -> Int# Source #

alignmentOfType# :: Proxy (Const a b) -> Int# Source #

alignment# :: Const a b -> Int# Source #

indexByteArray# :: ByteArray# -> Int# -> Const a b Source #

readByteArray# :: MutableByteArray# s -> Int# -> State# s -> (# State# s, Const a b #) Source #

writeByteArray# :: MutableByteArray# s -> Int# -> Const a b -> State# s -> State# s Source #

setByteArray# :: MutableByteArray# s -> Int# -> Int# -> Const a b -> State# s -> State# s Source #

indexOffAddr# :: Addr# -> Int# -> Const a b Source #

readOffAddr# :: Addr# -> Int# -> State# s -> (# State# s, Const a b #) Source #

writeOffAddr# :: Addr# -> Int# -> Const a b -> State# s -> State# s Source #

setOffAddr# :: Addr# -> Int# -> Int# -> Const a b -> State# s -> State# s Source #

class Monad m => PrimMonad (m :: Type -> Type) Source #

Class of monads which can perform primitive state-transformer actions.

Minimal complete definition

primitive

#### Instances

Instances details

PrimMonad IO |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState IO |
Instance details Defined in Control.Monad.Primitive type PrimState IO = RealWorld

Methods

primitive :: (State# (PrimState IO) -> (# State# (PrimState IO), a #)) -> IO a Source #

PrimMonad (ST s) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (ST s) |
Instance details Defined in Control.Monad.Primitive type PrimState (ST s) = s

Methods

primitive :: (State# (PrimState (ST s)) -> (# State# (PrimState (ST s)), a #)) -> ST s a Source #

PrimMonad (ST s) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (ST s) |
Instance details Defined in Control.Monad.Primitive type PrimState (ST s) = s

Methods

primitive :: (State# (PrimState (ST s)) -> (# State# (PrimState (ST s)), a #)) -> ST s a Source #

PrimMonad m => PrimMonad (MaybeT m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (MaybeT m) |
Instance details Defined in Control.Monad.Primitive type PrimState (MaybeT m) = PrimState m

Methods

primitive :: (State# (PrimState (MaybeT m)) -> (# State# (PrimState (MaybeT m)), a #)) -> MaybeT m a Source #

(Monoid w, PrimMonad m) => PrimMonad (AccumT w m) | Since: primitive-0.6.3.0

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (AccumT w m) |
Instance details Defined in Control.Monad.Primitive type PrimState (AccumT w m) = PrimState m

Methods

primitive :: (State# (PrimState (AccumT w m)) -> (# State# (PrimState (AccumT w m)), a #)) -> AccumT w m a Source #

PrimMonad m => PrimMonad (ExceptT e m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (ExceptT e m) |
Instance details Defined in Control.Monad.Primitive type PrimState (ExceptT e m) = PrimState m

Methods

primitive :: (State# (PrimState (ExceptT e m)) -> (# State# (PrimState (ExceptT e m)), a #)) -> ExceptT e m a Source #

PrimMonad m => PrimMonad (IdentityT m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (IdentityT m) |
Instance details Defined in Control.Monad.Primitive type PrimState (IdentityT m) = PrimState m

Methods

primitive :: (State# (PrimState (IdentityT m)) -> (# State# (PrimState (IdentityT m)), a #)) -> IdentityT m a Source #

PrimMonad m => PrimMonad (ReaderT r m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (ReaderT r m) |
Instance details Defined in Control.Monad.Primitive type PrimState (ReaderT r m) = PrimState m

Methods

primitive :: (State# (PrimState (ReaderT r m)) -> (# State# (PrimState (ReaderT r m)), a #)) -> ReaderT r m a Source #

PrimMonad m => PrimMonad (SelectT r m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (SelectT r m) |
Instance details Defined in Control.Monad.Primitive type PrimState (SelectT r m) = PrimState m

Methods

primitive :: (State# (PrimState (SelectT r m)) -> (# State# (PrimState (SelectT r m)), a #)) -> SelectT r m a Source #

PrimMonad m => PrimMonad (StateT s m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (StateT s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (StateT s m) = PrimState m

Methods

primitive :: (State# (PrimState (StateT s m)) -> (# State# (PrimState (StateT s m)), a #)) -> StateT s m a Source #

PrimMonad m => PrimMonad (StateT s m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (StateT s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (StateT s m) = PrimState m

Methods

primitive :: (State# (PrimState (StateT s m)) -> (# State# (PrimState (StateT s m)), a #)) -> StateT s m a Source #

(Monoid w, PrimMonad m) => PrimMonad (WriterT w m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (WriterT w m) |
Instance details Defined in Control.Monad.Primitive type PrimState (WriterT w m) = PrimState m

Methods

primitive :: (State# (PrimState (WriterT w m)) -> (# State# (PrimState (WriterT w m)), a #)) -> WriterT w m a Source #

(Monoid w, PrimMonad m) => PrimMonad (WriterT w m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (WriterT w m) |
Instance details Defined in Control.Monad.Primitive type PrimState (WriterT w m) = PrimState m

Methods

primitive :: (State# (PrimState (WriterT w m)) -> (# State# (PrimState (WriterT w m)), a #)) -> WriterT w m a Source #

(Monoid w, PrimMonad m) => PrimMonad (WriterT w m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (WriterT w m) |
Instance details Defined in Control.Monad.Primitive type PrimState (WriterT w m) = PrimState m

Methods

primitive :: (State# (PrimState (WriterT w m)) -> (# State# (PrimState (WriterT w m)), a #)) -> WriterT w m a Source #

PrimMonad m => PrimMonad (ContT r m) | Since: primitive-0.6.3.0

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (ContT r m) |
Instance details Defined in Control.Monad.Primitive type PrimState (ContT r m) = PrimState m

Methods

primitive :: (State# (PrimState (ContT r m)) -> (# State# (PrimState (ContT r m)), a #)) -> ContT r m a Source #

(Monoid w, PrimMonad m) => PrimMonad (RWST r w s m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (RWST r w s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (RWST r w s m) = PrimState m

Methods

primitive :: (State# (PrimState (RWST r w s m)) -> (# State# (PrimState (RWST r w s m)), a #)) -> RWST r w s m a Source #

(Monoid w, PrimMonad m) => PrimMonad (RWST r w s m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (RWST r w s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (RWST r w s m) = PrimState m

Methods

primitive :: (State# (PrimState (RWST r w s m)) -> (# State# (PrimState (RWST r w s m)), a #)) -> RWST r w s m a Source #

(Monoid w, PrimMonad m) => PrimMonad (RWST r w s m) |

Instance details

Defined in Control.Monad.Primitive

Associated Types

type PrimState (RWST r w s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (RWST r w s m) = PrimState m

Methods

primitive :: (State# (PrimState (RWST r w s m)) -> (# State# (PrimState (RWST r w s m)), a #)) -> RWST r w s m a Source #

type family PrimState (m :: Type -> Type) Source #

State token type.

#### Instances

Instances details

type PrimState IO |
Instance details Defined in Control.Monad.Primitive type PrimState IO = RealWorld
type PrimState (ST s) |
Instance details Defined in Control.Monad.Primitive type PrimState (ST s) = s
type PrimState (ST s) |
Instance details Defined in Control.Monad.Primitive type PrimState (ST s) = s
type PrimState (MaybeT m) |
Instance details Defined in Control.Monad.Primitive type PrimState (MaybeT m) = PrimState m
type PrimState (AccumT w m) |
Instance details Defined in Control.Monad.Primitive type PrimState (AccumT w m) = PrimState m
type PrimState (ExceptT e m) |
Instance details Defined in Control.Monad.Primitive type PrimState (ExceptT e m) = PrimState m
type PrimState (IdentityT m) |
Instance details Defined in Control.Monad.Primitive type PrimState (IdentityT m) = PrimState m
type PrimState (ReaderT r m) |
Instance details Defined in Control.Monad.Primitive type PrimState (ReaderT r m) = PrimState m
type PrimState (SelectT r m) |
Instance details Defined in Control.Monad.Primitive type PrimState (SelectT r m) = PrimState m
type PrimState (StateT s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (StateT s m) = PrimState m
type PrimState (StateT s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (StateT s m) = PrimState m
type PrimState (WriterT w m) |
Instance details Defined in Control.Monad.Primitive type PrimState (WriterT w m) = PrimState m
type PrimState (WriterT w m) |
Instance details Defined in Control.Monad.Primitive type PrimState (WriterT w m) = PrimState m
type PrimState (WriterT w m) |
Instance details Defined in Control.Monad.Primitive type PrimState (WriterT w m) = PrimState m
type PrimState (ContT r m) |
Instance details Defined in Control.Monad.Primitive type PrimState (ContT r m) = PrimState m
type PrimState (RWST r w s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (RWST r w s m) = PrimState m
type PrimState (RWST r w s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (RWST r w s m) = PrimState m
type PrimState (RWST r w s m) |
Instance details Defined in Control.Monad.Primitive type PrimState (RWST r w s m) = PrimState m

data RealWorld Source #

`RealWorld` is deeply magical. It is primitive, but it is not unlifted (hence `ptrArg`). We never manipulate values of type `RealWorld`; it's only used in the type system, to parameterise `State#`.